<?php
/*
 * Created on 25. Sep 06
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

class webFTP
{
	var $conn_id = FALSE;
	var $server = FALSE;
	var $user = FALSE;
	var $passwd = FALSE;
	var $path = FALSE;
	
	function webFTP($server='', $user='', $passwd = '')
	{
		$this->server = $server;
		$this->user = $user;
		$this->passwd = $passwd;
		$this->path = '/';
	}
	
	function connect_ftp()
	{
		if ($this->server)
		{
			// Herstellen der Basis-Verbindung
			$this->conn_id = ftp_connect("$this->server");

			if ($this->conn_id)
			{
				// Einloggen mit Benutzername und Kennwort
				$login_result = ftp_login($this->conn_id, "$this->user", "$this->passwd"); 
				
				// Verbindung überprüfen
				if ((!$this->conn_id) || (!$login_result))
				{ 
//					echo "Ftp-Verbindung nicht hergestellt!";
//					echo "Verbindung mit $ftp_server als Benutzer $ftp_user_name nicht möglich"; 
					return FALSE;
					die; 
				}
				else
				{
//					echo "Verbunden mit $ftp_server als Benutzer $ftp_user_name";
					return TRUE;
				}
			}
			else return FALSE;
		}
	}
	
	function close_ftp()
	{
		// Schließen des FTP-Streams
		ftp_quit($this->conn_id);
	}
	
	function empty_dir($conn_id,$dir)
	{
		$rawlist = ftp_rawlist($conn_id,$dir);
		if (count($rawlist)>0)return FALSE;
		return TRUE;
	}
	
	function raw_split($row)
	{
		$t = split(' ',$row);
//			echo "<pre>";
//			print_r($t);
//			echo "</pre>";
		foreach($t AS $key => $value)
		{
			if (strlen($value) < 1)unset($t[$key]);
		}
		return $t;
	}

	function file_type($rechte)
	{
		$type = $rechte[0];
		if ($type == 'd') $type = 'Verzeichnis';
		elseif ($type == 'l') $type = 'Link';
		elseif ($type == "-") $type = 'Datei';
		return $type;
	}
	
	function size_unit($wert)
	{
		$einheit = array('','K','M','G','T','P');
		$w = $wert;
		for($i=0, $anz = count($einheit);$i < $anz; $i++)
		{
			if($w/1024 < 1)break;
			else $w /=1024;
		}
		
		$out = $i > 0 ? sprintf("%.2f %sB",$w,$einheit[$i]):sprintf("%d %sB",$w,$einheit[$i]);
		return $out;
	}

	function ftp_list($dir, &$dirs, &$files)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			$rawlist = ftp_rawlist($this->conn_id,$dir);
			$this->close_ftp();

			foreach($rawlist AS $key => $value)
			{
				$temp[$key] = $this->raw_split($value);
			}
			
			$dirs = $files = array();
			if(!empty($temp))
			{
				foreach($temp AS $key => $value)
				{
					$i = $k = 0;
					$name = '';
					foreach($value as $item)
					{
						if ($i == 0)$type = $this->file_type($rechte = $item); // Anhand der Rechte unterscheiden ob dir oder file
						if ($i == 4)$groesse = $this->size_unit($item);
						if ($i == 5)$monat = $item;
						if ($i == 6)$tag = $item;
						if ($i == 7)$zeit = $item;
						if ($i >= 8)$name.= $item;
						$i++;
					}
					if($type == 'Verzeichnis')
						array_push($dirs, array('Name' => $name, 'Rechte' => $rechte, 'Type' => $type, 'Size' => $groesse, 'Datum' => $tag.'. '.$monat, 'Zeit' => $zeit));
					if ($type == 'Datei')
						array_push($files, array('Name' => $name, 'Rechte' => $rechte, 'Type' => $type, 'Size' => $groesse, 'Datum' => $tag.'. '.$monat, 'Zeit' => $zeit));
				}
			}
			return true;
		}
	}

	function ftp_upload($path)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			// Erst Verzeichnis wechseln
			if(!ftp_chdir($this->conn_id, $path)) return FALSE;
			else
			{
				// Upload der Datei und prüfen des Status
				if (!($upload = ftp_put($this->conn_id, $_FILES['upload']['name'], $_FILES['upload']['tmp_name'], FTP_BINARY)))
					return FALSE; 
//					echo "Ftp upload war fehlerhaft!";
				else
					return TRUE;	
//					echo "Datei $quelle auf $ftp_server als $ziel geschrieben";
			}
			$this->close_ftp();
		}
	}
	
	function ftp_download($path,$file)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			$basedir = "./tmp/";
			// Download einer Datei auf den lokalen Server
			if(!($download = ftp_get($this->conn_id,$basedir.$file, $path.$file, FTP_BINARY)))
				return FALSE;
			else
			{
				// Vertrauenswürdigen Dateinamen basteln.
				$filename = sprintf("%s%s", $basedir, $file);
				
				// Passenden Datentyp erzeugen.
				header("Content-Type: application/octet-stream");
				
				// Passenden Dateinamen im Download-Requester vorgeben,
				// z. B. den Original-Dateinamen
				$save_as_name = basename($file);
				header("Content-Disposition: attachment; filename=\"$save_as_name\"");
				
				readfile($filename);// Datei ausgeben.
				unlink($basedir.$file);
				return TRUE;
			}
			$this->close_ftp();
		}
	}
	
	function ftp_rname($path, $from, $to)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			// Erst Verzeichnis wechseln
			if(!ftp_chdir($this->conn_id, $path)) return FALSE;
			else
			{
				if(!ftp_rename($this->conn_id, $from, $to))
					return FALSE;
				else
					return TRUE;
			}
		}
	}
	
	function ftp_del($path,$dir,$file)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			// Erst Verzeichnis wechseln
			if(!ftp_chdir($this->conn_id, $path)) return FALSE;
			else
			{
				if($dir)
				{
					if($this->empty_dir($this->conn_id, $dir))
						if(!ftp_rmdir($this->conn_id, $dir))
							return FALSE;
						else
							return TRUE;
					else
					{
						$this->ftp_rmdirr($dir);
					}
				}
				else
				{
					if(!ftp_delete($this->conn_id, $file))
						return FALSE;
					else
						return TRUE;
				}
			}
		}
	}
	
	function ftp_rmdirr($path)
	{
		if (!(@ftp_rmdir($this->conn_id, $path) || @ftp_delete($this->conn_id, $path)))
		{
			$list = ftp_nlist($this->conn_id, $path);
			if (!empty($list))
				foreach($list as $value)
					$this->ftp_rmdirr($value, $this->conn_id);
		}
		ftp_rmdir($this->conn_id, $path);
	} 
   	
	function ftp_newdir($path,$fname)
	{
		if(!$this->connect_ftp()) return FALSE;
		else
		{
			// Erst Verzeichnis wechseln
			if(!ftp_chdir($this->conn_id, $path)) return FALSE;
			else
			{
				if(!ftp_mkdir($this->conn_id, $fname))
					return FALSE;
				else
					return TRUE;
			}
		}
	}
}
?>
